`include "define.h"

module Control( IR, SESel, WBcontrol, MEMcontrol, EXcontrol, Halt );
input   [`DATA] IR;
output          SESel;
output [2:0]	WBcontrol;
output [2:0]	MEMcontrol;
output [4:0]	EXcontrol;
output 		Halt;

assign Halt = `CTLOPCODE == `HLT ? 1 : 0;

assign SESel = `CTLOPCODE === `J ? 1 : 0;

assign `CTLREGRW = `CTLOPCODE === `FSEL ? ( IR === `DATAWIDTH'b0 ? 0 : 1 ) :
		   `CTLOPCODE === `ADDI ? 1 :
		   `CTLOPCODE === `LW ? 1 : 0;
assign `CTLREGDST = `CTLOPCODE === `FSEL ? 1 : 0;
assign `CTLWBSEL = `CTLOPCODE === `FSEL ? 1 :
		   `CTLOPCODE === `ADDI ? 1 : 0;
		  
assign `CTLMEMRW = `CTLOPCODE === `SW ? 1 : 0;
assign `CTLJMPE = `CTLOPCODE === `J ? 1 : 0;
assign `CTLBRAE = `CTLOPCODE === `BEQZ ? 1 :
		  `CTLOPCODE === `BNEZ ? 1 : 0;
		 
assign `CTLALUOPCODE = 	`CTLOPCODE === `FSEL ? `RTYPE :
		        `CTLOPCODE === `ADDI ? `ITYPE :
		        `CTLOPCODE === `J ? `BRANCH :
		        `CTLOPCODE === `BEQZ ? `BRANCH :
		        `CTLOPCODE === `BNEZ ? `BRANCH : `MEMACC;
assign `CTLZSEL = `CTLOPCODE === `BNEZ ? 1 : 0;
assign `CTLALUINA = `CTLOPCODE === `FSEL ? 1 :
		    `CTLOPCODE === `ADDI ? 1 :	
		    `CTLOPCODE === `SW ? 1 :
		    `CTLOPCODE === `LW ? 1 : 0;
assign `CTLALUINB = `CTLOPCODE !== `FSEL ? 1 :
 		    `CTLFUNC === `SLL ? 1 :
 		    `CTLFUNC === `SRL ? 1 : 0;
                     		       	 		  
endmodule /* Control */
