`include "define.h"

module RegFile (
        RdReg1,
        RdReg2,
        WrtReg,
        WrtData,
        R1Out,
        R2Out,
        RegWrite,
        Clk );

input   [`RDDR] RdReg1, RdReg2, WrtReg;
input   [`DATA] WrtData;
output  [`DATA] R1Out, R2Out;
input           RegWrite;
input           Clk;

wire    [`DATA] R1Out, R2Out;

wire    [`DATA] r0, r1, r2, r3, r4, r5, r6, r7, r8, r9,
                r10, r11, r12, r13, r14, r15, r16, r17, r18, r19,
                r20, r21, r22, r23, r24, r25, r26, r27, r28, r29,
                r30, r31;

wire    rw0  = WrtReg ==  0 && RegWrite,
        rw1  = WrtReg ==  1 && RegWrite,
        rw2  = WrtReg ==  2 && RegWrite,
        rw3  = WrtReg ==  3 && RegWrite,
        rw4  = WrtReg ==  4 && RegWrite,
        rw5  = WrtReg ==  5 && RegWrite,
        rw6  = WrtReg ==  6 && RegWrite,
        rw7  = WrtReg ==  7 && RegWrite,
        rw8  = WrtReg ==  8 && RegWrite,
        rw9  = WrtReg ==  9 && RegWrite,
        rw10 = WrtReg == 10 && RegWrite,
        rw11 = WrtReg == 11 && RegWrite,
        rw12 = WrtReg == 12 && RegWrite,
        rw13 = WrtReg == 13 && RegWrite,
        rw14 = WrtReg == 14 && RegWrite,
        rw15 = WrtReg == 15 && RegWrite,
        rw16 = WrtReg == 16 && RegWrite,
        rw17 = WrtReg == 17 && RegWrite,
        rw18 = WrtReg == 18 && RegWrite,
        rw19 = WrtReg == 19 && RegWrite,
        rw20 = WrtReg == 20 && RegWrite,
        rw21 = WrtReg == 21 && RegWrite,
        rw22 = WrtReg == 22 && RegWrite,
        rw23 = WrtReg == 23 && RegWrite,
        rw24 = WrtReg == 24 && RegWrite,
        rw25 = WrtReg == 25 && RegWrite,
        rw26 = WrtReg == 26 && RegWrite,
        rw27 = WrtReg == 27 && RegWrite,
        rw28 = WrtReg == 28 && RegWrite,
        rw29 = WrtReg == 29 && RegWrite,
        rw30 = WrtReg == 30 && RegWrite,
        rw31 = WrtReg == 31 && RegWrite;

Register R0  ( r0, `DATAWIDTH'b0, rw0, Clk),
         R1  ( r1, WrtData, rw1, Clk),
         R2  ( r2, WrtData, rw2, Clk),
         R3  ( r3, WrtData, rw3, Clk),
         R4  ( r4, WrtData, rw4, Clk),
         R5  ( r5, WrtData, rw5, Clk),
         R6  ( r6, WrtData, rw6, Clk),
         R7  ( r7, WrtData, rw7, Clk),
         R8  ( r8, WrtData, rw8, Clk),
         R9  ( r9, WrtData, rw9, Clk),
         R10 (r10, WrtData, rw10, Clk),
         R11 (r11, WrtData, rw11, Clk),
         R12 (r12, WrtData, rw12, Clk),
         R13 (r13, WrtData, rw13, Clk),
         R14 (r14, WrtData, rw14, Clk),
         R15 (r15, WrtData, rw15, Clk),
         R16 (r16, WrtData, rw16, Clk),
         R17 (r17, WrtData, rw17, Clk),
         R18 (r18, WrtData, rw18, Clk),
         R19 (r19, WrtData, rw19, Clk),
         R20 (r20, WrtData, rw20, Clk),
         R21 (r21, WrtData, rw21, Clk),
         R22 (r22, WrtData, rw22, Clk),
         R23 (r23, WrtData, rw23, Clk),
         R24 (r24, WrtData, rw24, Clk),
         R25 (r25, WrtData, rw25, Clk),
         R26 (r26, WrtData, rw26, Clk),
         R27 (r27, WrtData, rw27, Clk),
         R28 (r28, WrtData, rw28, Clk),
         R29 (r29, WrtData, rw29, Clk),
         R30 (r30, WrtData, rw30, Clk),
         R31 (r31, WrtData, rw31, Clk);

RegMux R1Mux(RdReg1, R1Out,
        r0, r1, r2, r3, r4, r5, r6, r7, r8, r9,
        r10, r11, r12, r13, r14, r15, r16, r17, r18, r19,
        r20, r21, r22, r23, r24, r25, r26, r27, r28, r29,
        r30, r31);

RegMux R2Mux(RdReg2, R2Out,
        r0, r1, r2, r3, r4, r5, r6, r7, r8, r9,
        r10, r11, r12, r13, r14, r15, r16, r17, r18, r19,
        r20, r21, r22, r23, r24, r25, r26, r27, r28, r29,
        r30, r31);

initial
   R0.RegBuf = `DATAWIDTH'b0;

endmodule /* RegFile */

module RegMux (S, RegOut,
        r0, r1, r2, r3, r4, r5, r6, r7, r8, r9,
        r10, r11, r12, r13, r14, r15, r16, r17, r18, r19,
        r20, r21, r22, r23, r24, r25, r26, r27, r28, r29,
        r30, r31);

input   [`RDDR] S;
output  [`DATA] RegOut;
input   [`DATA] r0, r1, r2, r3, r4, r5, r6, r7, r8, r9,
                r10, r11, r12, r13, r14, r15, r16, r17, r18, r19,
                r20, r21, r22, r23, r24, r25, r26, r27, r28, r29,
                r30, r31;

assign  RegOut = S == 0  ? r0 :
                 S == 1  ? r1 :
                 S == 2  ? r2 :
                 S == 3  ? r3 :
                 S == 4  ? r4 :
                 S == 5  ? r5 :
                 S == 6  ? r6 :
                 S == 7  ? r7 :
                 S == 8  ? r8 :
                 S == 9  ? r9 :
                 S == 10 ? r10 :
                 S == 11 ? r11 :
                 S == 12 ? r12 :
                 S == 13 ? r13 :
                 S == 14 ? r14 :
                 S == 15 ? r15 :
                 S == 16 ? r16 :
                 S == 17 ? r17 :
                 S == 18 ? r18 :
                 S == 19 ? r19 :
                 S == 20 ? r20 :
                 S == 21 ? r21 :
                 S == 22 ? r22 :
                 S == 23 ? r23 :
                 S == 24 ? r24 :
                 S == 25 ? r25 :
                 S == 26 ? r26 :
                 S == 27 ? r27 :
                 S == 28 ? r28 :
                 S == 29 ? r29 :
                 S == 30 ? r30 : r31;

endmodule /* RegMux */

